  /*  **********************************************************************
    Source:     im_Test.C

    Purpose:    this module contains the Test stuff for the newsreader functionality
    **********************************************************************/

#include	<windows.h>
#include	<windowsx.h> 
#include	"tcpmdlw.h"   
#include	"testpgm.h"
 

// Function:    popTest1()
//
// Purpose:     Main Window procedure
//
//***********************************************************************

LRESULT popTest1 (LPTESTBLOCK lpTestBlock, UINT error)
{

#define		CONNECT_PENDING		1 
#define		LOGON_PENDING		2          
#define		STATUS_PENDING		3
#define		HEADERS_PENDING		4
#define		ARTICLES_PENDING	5
#define		DELETE_PENDING		6           
#define		DISCONNECT_PENDING	7

LPTMEVENT	lpEvent; 
int			count = 0;
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{   
			ResetDebug();
			OutputDebug("POP Test 1 starting...");
		    imInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) POP_SERVER);
			OutputDebug(outBuf);
			imConnect(lpTestBlock, POP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connect failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							wsprintf(outBuf, "Logging on as %s", (LPSTR) MY_ID);	
							OutputDebug(outBuf);
							imLogon(lpTestBlock, MY_ID, MY_PSWD);
							lpTestBlock->state = LOGON_PENDING;
						}
						break;
				    
				    case LOGON_PENDING:
				    	OutputDebug("Logged on");
						wsprintf(outBuf, "Mailbox entries: start = %lu, end = %lu", (long) lpEvent->dStart, (long) lpEvent->dEnd);	
						OutputDebug(outBuf);
						OutputDebug("Getting first two mail items");                     
						imGetMail(lpTestBlock, lpEvent->dStart, lpEvent->dStart+1);
						lpTestBlock->state = ARTICLES_PENDING;		
						break;
									
					case ARTICLES_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)                    
						{
							count++;           
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							imDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 1 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;
}          


LRESULT popTest2 (LPTESTBLOCK lpTestBlock, UINT error)
{                                	

LPTMEVENT	lpEvent; 
int			count = 0;                     
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{   
			ResetDebug();
			OutputDebug("POP Test 2 starting...");
		    imInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) POP_SERVER);
			OutputDebug(outBuf);
			imConnect(lpTestBlock, POP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connect failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							wsprintf(outBuf, "Logging on as %s", (LPSTR) MY_ID);	
							OutputDebug(outBuf);
							imLogon(lpTestBlock, MY_ID, MY_PSWD);
							lpTestBlock->state = LOGON_PENDING;
						}
						break;
				    
				    case LOGON_PENDING:
				    	OutputDebug("Logged on");
						wsprintf(outBuf, "Mailbox entries: start = %lu, end = %lu", (long) lpEvent->dStart, (long) lpEvent->dEnd);	
						OutputDebug(outBuf);
						OutputDebug("Getting all mail looking for <test>");
						tmSetIncludeMask(lpTestBlock, TMMASK_ALL, "[*Internet MiddleWare Test-PGM test*]");                  
						imGetMail(lpTestBlock, 0, 0);
						lpTestBlock->state = ARTICLES_PENDING;		
						break;
									          
					case ARTICLES_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)                    
						{
							count++;           
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							imDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 2 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;

		return 0;		
}          



LRESULT popTest3 (LPTESTBLOCK lpTestBlock, UINT error)
{                                	

LPTMEVENT	lpEvent; 
int			count = 0;                     
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{   
			ResetDebug();
			OutputDebug("POP Test 3 starting...");
		    imInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) POP_SERVER);
			OutputDebug(outBuf);
			imConnect(lpTestBlock, POP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connect failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							wsprintf(outBuf, "Logging on as %s", (LPSTR) MY_ID);	
							OutputDebug(outBuf);
							imLogon(lpTestBlock, MY_ID, MY_PSWD);
							lpTestBlock->state = LOGON_PENDING;
						}
						break;
				    
				    case LOGON_PENDING:
				    	OutputDebug("Logged on");
						wsprintf(outBuf, "Mailbox entries: start = %lu, end = %lu", (long) lpEvent->dStart, (long) lpEvent->dEnd);	
						OutputDebug(outBuf);
						OutputDebug("Getting all mail headers");
						imGetHeaders(lpTestBlock, 0, 0);
						lpTestBlock->state = HEADERS_PENDING;		
						break;
									          
					case HEADERS_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)                    
						{
							count++;           
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							imDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 3 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;

		return 0;		
}          

