  /*  **********************************************************************
    Source:     nr_Test.C

    Purpose:    this module contains the Test stuff for the newsreader functionality
    **********************************************************************/

#include	<windows.h>
#include	<windowsx.h> 
#include	"tcpmdlw.h"   
#include	"testpgm.h"
 


// Function:    newsTest1()
//
// Purpose:     Main Window procedure
//
//***********************************************************************

LRESULT newsTest1 (LPTESTBLOCK lpTestBlock, UINT error)
{

#define		CONNECT_PENDING		1
#define		GROUPS_PENDING		2
#define		INFO_PENDING		3
#define		HEADERS_PENDING		4
#define		ARTICLES_PENDING	5           
#define		DISCONNECT_PENDING	6

LPTMEVENT	lpEvent; 
int			count = 0;
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{   
			ResetDebug();
			OutputDebug("Test 1 starting...");
		    nrInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) NNTP_SERVER);
			OutputDebug(outBuf);
			nrConnect(lpTestBlock, NNTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connect failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							OutputDebug("Getting group information");
							nrGetGroupInfo(lpTestBlock, "rec.woodworking");
							lpTestBlock->state = INFO_PENDING;
						}
						break;
				
					case INFO_PENDING:
						wsprintf(outBuf, "rec.woodworking: start = %lu, end = %lu", (long) lpEvent->dStart, (long) lpEvent->dEnd);	
						OutputDebug(outBuf);
						OutputDebug("Getting first 2 headers");
						nrGetHeaders(lpTestBlock, lpEvent->szGroup, lpEvent->dStart, lpEvent->dStart+1);
						lpTestBlock->state = HEADERS_PENDING;		
						break;
									
					case HEADERS_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)
						{
							count++;                                                 
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						OutputDebug("Getting first two articles");                     
						nrGetArticles(lpTestBlock, lpEvent->szGroup, lpEvent->dStart, lpEvent->dStart+1);
						lpTestBlock->state = ARTICLES_PENDING;		
						break;
									
					case ARTICLES_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)                    
						{
							count++;           
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							nrDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 1 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;
}          


LRESULT newsTest2 (LPTESTBLOCK lpTestBlock, UINT error)
{
#define		CONNECT_PENDING		1
#define		GROUPS_PENDING		2
#define		INFO_PENDING		3
#define		HEADERS_PENDING		4
#define		ARTICLES_PENDING	5           
#define		DISCONNECT_PENDING	6                    

LPTMEVENT	lpEvent; 
int			count = 0;

		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{                      
			ResetDebug();
			OutputDebug("Test 2 starting...");
		    nrInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) NNTP_SERVER);
			OutputDebug(outBuf);
			nrConnect(lpTestBlock, NNTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connect failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							OutputDebug("Getting all newsgroups");
							nrGetGroups(lpTestBlock);
							lpTestBlock->state = GROUPS_PENDING;
						}
						break;
				
					case GROUPS_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)        
						{   
							count++;
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							nrDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 2 complete");
						termTest(lpTestBlock);
						break;
				}		
		
	   	  	}
		}


		return 0;		
}          


LRESULT newsTest3 (LPTESTBLOCK lpTestBlock, UINT error)
{
LPTMEVENT	lpEvent; 
int			count = 0;     
LRESULT		rc;

		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{                      
			ResetDebug();
			OutputDebug("Test 3 starting...");
		    nrInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) NNTP_SERVER);
			OutputDebug(outBuf);
			nrConnect(lpTestBlock, NNTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connect failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							OutputDebug("Getting newsgroups that contain ms-windows or tcp-ip but not nt");
							rc = tmSetIncludeMask(lpTestBlock, TMMASK_ALL, "[*ms-windows*] | [*tcp-ip*]");
							rc = tmSetExcludeMask(lpTestBlock, TMMASK_ALL, "[*nt*] | [*vms*]");
							if (rc) 
							{   
								OutputDebug("Bad mask");
								OutputDebug("Disconnecting");
								nrDisConnect(lpTestBlock);
								lpTestBlock->state = DISCONNECT_PENDING;		
							}
							else
							{
								nrGetGroups(lpTestBlock);
								lpTestBlock->state = GROUPS_PENDING;
							}		
						}
						break;
				
					case GROUPS_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)        
						{   
							count++;
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							nrDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 3 complete");
						termTest(lpTestBlock);
						break;
				}		
		
	   	  	}
		}



	return 0;

} 

LRESULT newsTest4 (LPTESTBLOCK lpTestBlock, UINT error)
{

#define		CONNECT_PENDING		1
#define		GROUPS_PENDING		2
#define		INFO_PENDING		3
#define		HEADERS_PENDING		4
#define		ARTICLES_PENDING	5           
#define		DISCONNECT_PENDING	6
#define		POST_PENDING		7

LPTMEVENT	lpEvent; 
int			count = 0;
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{   
			ResetDebug();
			OutputDebug("Test 1 starting...");
		    nrInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) NNTP_SERVER);
			OutputDebug(outBuf);
			nrConnect(lpTestBlock, NNTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connection failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							OutputDebug("Posting to alt.test");
							nrPostArticle(lpTestBlock, "alt.test");
							nrDist(lpTestBlock, "world");
							nrSubject(lpTestBlock, "Ignore - Internet MiddleWare Test-PGM test");
							nrHeaderField(lpTestBlock, "X-Middleware", "Test Header Field");
							nrText(lpTestBlock, "line1\r\nline2");
							nrSend(lpTestBlock);
							lpTestBlock->state = POST_PENDING;
						}
						break;

   					case POST_PENDING:
						OutputDebug("Posting complete");
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							nrDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;

			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 1 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;
}          

LRESULT newsTest5 (LPTESTBLOCK lpTestBlock, UINT error)
{

#define		CONNECT_PENDING		1
#define		GROUPS_PENDING		2
#define		INFO_PENDING		3
#define		HEADERS_PENDING		4
#define		ARTICLES_PENDING	5           
#define		DISCONNECT_PENDING	6   
#define		FIELDS_PENDING		7

LPTMEVENT	lpEvent; 
int			count = 0;
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{   
			ResetDebug();
			OutputDebug("Test 1 starting...");
		    nrInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) NNTP_SERVER);
			OutputDebug(outBuf);
			nrConnect(lpTestBlock, NNTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Connect failed, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online"); 
							OutputDebug("Getting group information");
							nrGetGroupInfo(lpTestBlock, "alt.test");
							lpTestBlock->state = INFO_PENDING;
						}
						break;
				
					case INFO_PENDING:
						wsprintf(outBuf, "alt.test: start = %lu, end = %lu", (long) lpEvent->dStart, (long) lpEvent->dEnd);	
						OutputDebug(outBuf);
						OutputDebug("Getting X-Middleware fields");
						nrGetHeaderFields(lpTestBlock, lpEvent->szGroup, "X-Middleware", lpEvent->dStart, lpEvent->dEnd);
						lpTestBlock->state = FIELDS_PENDING;		
						break;
									
					case FIELDS_PENDING:
						OutputDebug(lpTestBlock->lpBfr);
						while (lpEvent->flags & TMFLG_MORE)
						{
							count++;                                                 
							tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN);
							OutputDebug(lpTestBlock->lpBfr);
						} 
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							nrDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 1 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;
}          

