  /*  **********************************************************************
    Source:     om_Test.C

    Purpose:    this module contains the Test stuff for the newsreader functionality
    **********************************************************************/

#include	<windows.h>
#include	<windowsx.h> 
#include	"tcpmdlw.h"   
#include	"testpgm.h"
 

// Function:    smtpTest1()
//
// Purpose:     Main Window procedure
//
//***********************************************************************

LRESULT smtpTest1 (LPTESTBLOCK lpTestBlock, UINT error)
{

#define		CONNECT_PENDING		1
#define		SEND_PENDING		2
#define		DISCONNECT_PENDING	6

LPTMEVENT	lpEvent; 
int			count = 0;
TMRESULT	rc = 0;
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{            
		
			ResetDebug();
			OutputDebug("SMTP Test 1 starting...");
		    omInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) SMTP_SERVER);
			OutputDebug(outBuf); 
			omConnect(lpTestBlock, SMTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Communications failure, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);                    
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online");  
							wsprintf(outBuf, "Sending mail to %s", (LPSTR) TESTTO);	
							OutputDebug(outBuf);
							omSendMail(lpTestBlock);
							omTo(lpTestBlock, TESTTO);
							omSubject(lpTestBlock, "Internet MiddleWare Test-PGM test");
							omText(lpTestBlock, "line1\r\nline2");
							omSend(lpTestBlock);
							lpTestBlock->state = SEND_PENDING;
						}
						break;
				
					case SEND_PENDING:
						OutputDebug("Sending of mail complete");
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							omDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 1 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;
}          

// Function:    smtpTest2()
//
// Purpose:     Send a note to myself.
//				1. use the FILE mechanism for TEXT commands
//				2. use the ATTACH command to attach some text
//
//***********************************************************************

LRESULT smtpTest2 (LPTESTBLOCK lpTestBlock, UINT error)
{

#define		CONNECT_PENDING		1
#define		SEND_PENDING		2
#define		DISCONNECT_PENDING	6

LPTMEVENT	lpEvent; 
int			count = 0;
TMRESULT	rc = 0;
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{            
		
			ResetDebug();
			OutputDebug("SMTP Test 2 starting...");
		    omInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) SMTP_SERVER);
			OutputDebug(outBuf); 
			omConnect(lpTestBlock, SMTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Communications failure, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);                    
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online");  
							wsprintf(outBuf, "Sending mail to %s", (LPSTR) TESTTO);	
							OutputDebug(outBuf);
							omSendMail(lpTestBlock);
							omTo(lpTestBlock, TESTTO);
							omSubject(lpTestBlock, "Internet MiddleWare Test-PGM test");
							omText(lpTestBlock, "inserting autoexec.bat\x0d\x0a");
							omText(lpTestBlock, ">file: \\autoexec.bat");
							omAttach(lpTestBlock, TMENC_UU, "test.bin");
							omSend(lpTestBlock);
							lpTestBlock->state = SEND_PENDING;
						}
						break;
				
					case SEND_PENDING:
						OutputDebug("Sending of mail complete");
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							omDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 1 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;
}          

// Function:    smtpTest3()
//
// Purpose:     Send a remote command note to myself.
//				1. use the REMOTECMD mechanism for execute commands
//					at the receiving end
//
//***********************************************************************

LRESULT smtpTest3 (LPTESTBLOCK lpTestBlock, UINT error)
{

#define		CONNECT_PENDING		1
#define		SEND_PENDING		2
#define		DISCONNECT_PENDING	6

LPTMEVENT	lpEvent; 
int			count = 0;
TMRESULT	rc = 0;
		
		lpEvent = lpTestBlock->lpEvent;

		if (lpTestBlock->state == IDLE)
		{            
		
			ResetDebug();
			OutputDebug("SMTP Test 3 starting...");
		    omInit(hMainWindow, lpTestBlock);
		    wsprintf(outBuf, "Connecting to %s", (LPSTR) SMTP_SERVER);
			OutputDebug(outBuf); 
			omConnect(lpTestBlock, SMTP_SERVER);
			lpTestBlock->state = CONNECT_PENDING;
        }
		else
		{
	   	  	if (error) 
	   	  	{
	   	  		tmError(lpTestBlock, lpEvent);
	   	  		wsprintf(outBuf, "Communications failure, error = %d", lpEvent->error);                      
				OutputDebug(outBuf);                    
				termTest(lpTestBlock);
			}	
	   	  	else
	   	  	{                               
				tmRead(lpTestBlock, lpEvent, lpTestBlock->lpBfr, BFRLEN-1);     /* keep a string terminator	*/
				switch (lpTestBlock->state)                                     /* in case the returned buffer */
				{                                                               /* takes up mu entire buffer	*/
					case CONNECT_PENDING:
						if (lpEvent->Online) 
						{        
							OutputDebug("Online");  
							wsprintf(outBuf, "Sending remote command <winfile.exe> to %s", (LPSTR) TESTTO);	
							OutputDebug(outBuf);
							omSendMail(lpTestBlock);
							omTo(lpTestBlock, TESTTO);
							omSubject(lpTestBlock, "Internet MiddleWare Test-PGM test");
							omText(lpTestBlock, "remote command test, File Manager should be active.\x0d\x0a");
							omRemoteCmd(lpTestBlock, NULL, TESTTO, "winfile.exe");
							omSend(lpTestBlock);
							lpTestBlock->state = SEND_PENDING;
						}
						break;
				
					case SEND_PENDING:
						OutputDebug("Sending of mail complete");
						if (lpEvent->flags & TMFLG_COMPLETE)
						{                      
							OutputDebug("Disconnecting");
							omDisConnect(lpTestBlock);
							lpTestBlock->state = DISCONNECT_PENDING;		
						}
						break;
			
					case DISCONNECT_PENDING:             
						OutputDebug("Offline");
						OutputDebug("Test 1 complete");
						termTest(lpTestBlock);
				}		
		
	   	  	}
		}


	return 0;
}          

